(function () {
	'use strict';
    var ormma = window.ormma = {};
    var listeners = {};
    ormma.fireErrorEvent = function (message, action) {
        var handlers = listeners['error'];
        if (handlers != null) {
            for (var i = 0; i < handlers.length; i++) {
                handlers[i](message, action);
            }
        }
        return;
    };
    ormma.fireKeyboardChangeEvent = function (open) {
        var handlers = listeners['keyboardChange'];
        if (handlers != null) {
            for (var i = 0; i < handlers.length; i++) {
                handlers[i](open);
            }
        }
        return;
    };
    ormma.fireReadyEvent = function () {
        var handlers = listeners['ready'];
        if (handlers != null) {
            for (var i = 0; i < handlers.length; i++) {
                handlers[i]();
            }
        }
        return;
    };
    ormma.fireStateChangeEvent = function (state) {
        var handlers = listeners['stateChange'];
        if (handlers != null) {
            for (var i = 0; i < handlers.length; i++) {
                handlers[i](state);
            }
        }
        return;
    };
    ormma.fireSizeChangeEvent = function (width, height) {
        var handlers = listeners['sizeChange'];
        if (handlers != null) {
            for (var i = 0; i < handlers.length; i++) {
                handlers[i](width, height);
            }
        }
        return;
    };
    ormma.fireViewableChangeEvent = function (onscreen) {
        var handlers = listeners['viewableChange'];
        if (handlers != null) {
            for (var i = 0; i < handlers.length; i++) {
                handlers[i](onscreen);
            }
        }
        return;
    };
    
    ormma.addEventListener = function (event, listener) {
        var handlers = listeners[event];
        if (handlers == null) {
            listeners[event] = [];
            handlers = listeners[event];
        }
        for (var handler in handlers) {
            if (listener == handler) {
                return;
            }
        }
        handlers.push(listener);
    };
    
    ormma.removeEventListener = function (event, listener) {
        var handlers = listeners[event];
        if (handlers != null) {
            handlers.remove(listener);
        }
    };
    
    ormma.removeEventListener = function (event, listener) {
        var handlers = listeners[event];
        if (handlers == null) {
            return;
        }
        if (listener == null) {
            handlers.splice(0, handlers.length);
            return;
        }
        var index = 0;
        while (index < handlers.length) {
            if (listener == handlers[index]) {
                handlers.splice(index, 1);
            }
            index++;
        }
    };
    ormma.close = function () {
        window.AdecoOrmmaBridge.close();
    };
    ormma.getState = function () {
        return window.AdecoOrmmaBridge.getState();
    };
    ormma.supports = function (feature) {
        return window.AdecoOrmmaBridge.supports(feature);
    };
    ormma.getVersion = function () {
        return window.AdecoOrmmaBridge.getVersion();
    };
    ormma.isViewable = function () {
        return window.AdecoOrmmaBridge.isViewable();
    };
    ormma.hide = function () {
        window.AdecoOrmmaBridge.hide();
    };
    ormma.open = function (url) {
        window.AdecoOrmmaBridge.open(url);
    };
    ormma.getPlacementType = function () {
        return window.AdecoOrmmaBridge.getPlacementType();
    };
    ormma.getSize = function () {
        return window.AdecoOrmmaBridge.getSize();
    };
    ormma.getDefaultPosition = function () {
        return window.AdecoOrmmaBridge.getDefaultPosition();
    };
    ormma.getMaxSize = function () {
        return window.AdecoOrmmaBridge.getMaxSize();
    };
    ormma.useCustomClose = function (useCustomClose) {
        window.AdecoOrmmaBridge.useCustomClose(useCustomClose);
    };
    ormma.ready = function () {
        window.AdecoOrmmaBridge.ready();
    };
    ormma.resize = function (width, height) {
        window.AdecoOrmmaBridge.resize(width, height);
    };
    ormma.expand = function (url) {
        window.AdecoOrmmaBridge.expand(url);
    };
    ormma.show = function () {
        window.AdecoOrmmaBridge.show();
    };
    ormma.getExpandProperties = function () {
        return window.AdecoOrmmaBridge.getExpandProperties();
    };
    ormma.setExpandProperties = function (json) {
        window.AdecoOrmmaBridge.setExpandProperties(json);
    };
    ormma.ORMMAReady = function () {};
    ormma.getViewable = function () {};
})();